package ufrn.imd.service.impl;

import lombok.AllArgsConstructor;
import lombok.extern.java.Log;
import ufrn.imd.domain.Client;
import ufrn.imd.repository.Repository;
import ufrn.imd.repository.impl.ClientRepository;
import ufrn.imd.service.Service;
import ufrn.imd.utils.ServerResponse;

@Log
@AllArgsConstructor
public class AuthenticatorServiceImpl implements Service {

    private final Repository<Client> clientRepository;

    public ServerResponse authenticate(String accountNumber) {
        Client client = ((ClientRepository) clientRepository).findByAccountNumber(accountNumber)
                .orElseThrow(() -> new RuntimeException(
                        String.format("Customer not found with account number %s", accountNumber)));

        log.info(client.getName() + " logged in (account number: " + client.getAccount().getNumber() + ")");
        return ServerResponse.builder()
                .status(200)
                .message("Operation sucessed!")
                .body(client.getId())
                .build();
    }
}
